# Generated by Django 3.1.8 on 2021-04-25 13:37

import django.core.validators
from django.db import migrations, models
import django.db.models.deletion
import edc_model.models.fields.other_charfield
import edc_model.models.validators.date


class Migration(migrations.Migration):

    dependencies = [
        ('edc_adverse_event', '0006_auto_20210425_1628'),
        ('inte_ae', '0006_auto_20210203_2009'),
    ]

    operations = [
        migrations.AddField(
            model_name='deathreport',
            name='comment',
            field=models.TextField(blank=True, help_text='Provide any additional details, if relevant', null=True, verbose_name='Comment'),
        ),
        migrations.AddField(
            model_name='deathreport',
            name='death_datetime',
            field=models.DateTimeField(null=True, validators=[edc_model.models.validators.date.datetime_not_future], verbose_name='Date and Time of Death'),
        ),
        migrations.AddField(
            model_name='historicaldeathreport',
            name='comment',
            field=models.TextField(blank=True, help_text='Provide any additional details, if relevant', null=True, verbose_name='Comment'),
        ),
        migrations.AddField(
            model_name='historicaldeathreport',
            name='death_datetime',
            field=models.DateTimeField(null=True, validators=[edc_model.models.validators.date.datetime_not_future], verbose_name='Date and Time of Death'),
        ),
        migrations.AlterField(
            model_name='deathreport',
            name='cause_of_death',
            field=models.ForeignKey(help_text='Main cause of death in the opinion of the local study doctor and local PI', null=True, on_delete=django.db.models.deletion.PROTECT, to='edc_adverse_event.causeofdeath', verbose_name='Main cause of death'),
        ),
        migrations.AlterField(
            model_name='deathreport',
            name='confirmed_by_other',
            field=edc_model.models.fields.other_charfield.OtherCharField(blank=True, max_length=35, null=True, verbose_name='If other, please specify ...'),
        ),
        migrations.AlterField(
            model_name='deathreport',
            name='death_location_other',
            field=edc_model.models.fields.other_charfield.OtherCharField(blank=True, max_length=35, null=True, verbose_name='If other, please specify ...'),
        ),
        migrations.AlterField(
            model_name='deathreport',
            name='informant_other',
            field=edc_model.models.fields.other_charfield.OtherCharField(blank=True, max_length=35, null=True, verbose_name='If other, please specify ...'),
        ),
        migrations.AlterField(
            model_name='deathreport',
            name='narrative',
            field=models.TextField(null=True, verbose_name='Narrative'),
        ),
        migrations.AlterField(
            model_name='deathreport',
            name='study_day',
            field=models.IntegerField(null=True, validators=[django.core.validators.MinValueValidator(1)], verbose_name='Study day'),
        ),
        migrations.AlterField(
            model_name='historicaldeathreport',
            name='cause_of_death',
            field=models.ForeignKey(blank=True, db_constraint=False, help_text='Main cause of death in the opinion of the local study doctor and local PI', null=True, on_delete=django.db.models.deletion.DO_NOTHING, related_name='+', to='edc_adverse_event.causeofdeath', verbose_name='Main cause of death'),
        ),
        migrations.AlterField(
            model_name='historicaldeathreport',
            name='confirmed_by_other',
            field=edc_model.models.fields.other_charfield.OtherCharField(blank=True, max_length=35, null=True, verbose_name='If other, please specify ...'),
        ),
        migrations.AlterField(
            model_name='historicaldeathreport',
            name='death_location_other',
            field=edc_model.models.fields.other_charfield.OtherCharField(blank=True, max_length=35, null=True, verbose_name='If other, please specify ...'),
        ),
        migrations.AlterField(
            model_name='historicaldeathreport',
            name='informant_other',
            field=edc_model.models.fields.other_charfield.OtherCharField(blank=True, max_length=35, null=True, verbose_name='If other, please specify ...'),
        ),
        migrations.AlterField(
            model_name='historicaldeathreport',
            name='narrative',
            field=models.TextField(null=True, verbose_name='Narrative'),
        ),
        migrations.AlterField(
            model_name='historicaldeathreport',
            name='study_day',
            field=models.IntegerField(null=True, validators=[django.core.validators.MinValueValidator(1)], verbose_name='Study day'),
        ),
    ]
