# Generated by Django 3.0.6 on 2020-07-01 04:40

import django.core.validators
from django.db import migrations, models


class Migration(migrations.Migration):

    dependencies = [
        ("inte_subject", "0013_auto_20200701_0304"),
    ]

    operations = [
        migrations.AddField(
            model_name="drugrefillhiv",
            name="clinic_days",
            field=models.IntegerField(
                default=0,
                help_text="days",
                validators=[
                    django.core.validators.MinValueValidator(0),
                    django.core.validators.MaxValueValidator(180),
                ],
                verbose_name="How many days supplied by the clinic",
            ),
            preserve_default=False,
        ),
        migrations.AddField(
            model_name="drugrefillhiv",
            name="club_days",
            field=models.IntegerField(
                default=0,
                help_text="days",
                validators=[
                    django.core.validators.MinValueValidator(0),
                    django.core.validators.MaxValueValidator(180),
                ],
                verbose_name="How many days supplied by a club",
            ),
            preserve_default=False,
        ),
        migrations.AddField(
            model_name="drugrefillhiv",
            name="purchased_days",
            field=models.IntegerField(
                default=0,
                help_text="This can be purchased by patient, through a medicines club that the patient belong to, through insurance or someone else has paid. ",
                validators=[
                    django.core.validators.MinValueValidator(0),
                    django.core.validators.MaxValueValidator(180),
                ],
                verbose_name="How many days supplied by to be purchase",
            ),
            preserve_default=False,
        ),
        migrations.AddField(
            model_name="historicaldrugrefillhiv",
            name="clinic_days",
            field=models.IntegerField(
                default=0,
                help_text="days",
                validators=[
                    django.core.validators.MinValueValidator(0),
                    django.core.validators.MaxValueValidator(180),
                ],
                verbose_name="How many days supplied by the clinic",
            ),
            preserve_default=False,
        ),
        migrations.AddField(
            model_name="historicaldrugrefillhiv",
            name="club_days",
            field=models.IntegerField(
                default=0,
                help_text="days",
                validators=[
                    django.core.validators.MinValueValidator(0),
                    django.core.validators.MaxValueValidator(180),
                ],
                verbose_name="How many days supplied by a club",
            ),
            preserve_default=False,
        ),
        migrations.AddField(
            model_name="historicaldrugrefillhiv",
            name="purchased_days",
            field=models.IntegerField(
                default=0,
                help_text="This can be purchased by patient, through a medicines club that the patient belong to, through insurance or someone else has paid. ",
                validators=[
                    django.core.validators.MinValueValidator(0),
                    django.core.validators.MaxValueValidator(180),
                ],
                verbose_name="How many days supplied by to be purchase",
            ),
            preserve_default=False,
        ),
        migrations.AlterField(
            model_name="drugrefilldiabetes",
            name="return_in_days",
            field=models.IntegerField(
                verbose_name="In how many days has the patient been asked to return to clinic for a drug refill?"
            ),
        ),
        migrations.AlterField(
            model_name="drugrefillhiv",
            name="return_in_days",
            field=models.IntegerField(
                verbose_name="In how many days has the patient been asked to return to clinic for a drug refill?"
            ),
        ),
        migrations.AlterField(
            model_name="drugrefillhypertension",
            name="return_in_days",
            field=models.IntegerField(
                verbose_name="In how many days has the patient been asked to return to clinic for a drug refill?"
            ),
        ),
        migrations.AlterField(
            model_name="historicaldrugrefilldiabetes",
            name="return_in_days",
            field=models.IntegerField(
                verbose_name="In how many days has the patient been asked to return to clinic for a drug refill?"
            ),
        ),
        migrations.AlterField(
            model_name="historicaldrugrefillhiv",
            name="return_in_days",
            field=models.IntegerField(
                verbose_name="In how many days has the patient been asked to return to clinic for a drug refill?"
            ),
        ),
        migrations.AlterField(
            model_name="historicaldrugrefillhypertension",
            name="return_in_days",
            field=models.IntegerField(
                verbose_name="In how many days has the patient been asked to return to clinic for a drug refill?"
            ),
        ),
    ]
