# Generated by Django 3.0.9 on 2020-09-26 22:43

from django.db import migrations, models


class Migration(migrations.Migration):

    dependencies = [
        ("inte_lists", "0007_auto_20200910_1742"),
        ("inte_subject", "0066_auto_20200926_2319"),
    ]

    operations = [
        migrations.AddField(
            model_name="dmreview",
            name="care_delivery",
            field=models.CharField(
                choices=[("Yes", "Yes"), ("No", "No"), ("N/A", "Not applicable")],
                default="N/A",
                help_text="Select `not applicable` if site was not selected for integrated care.",
                max_length=25,
                verbose_name="Was care for this `condition` delivered in an integrated care clinic today?",
            ),
        ),
        migrations.AddField(
            model_name="dmreview",
            name="care_delivery_other",
            field=models.TextField(
                blank=True, null=True, verbose_name="If no, please explain"
            ),
        ),
        migrations.AddField(
            model_name="historicaldmreview",
            name="care_delivery",
            field=models.CharField(
                choices=[("Yes", "Yes"), ("No", "No"), ("N/A", "Not applicable")],
                default="N/A",
                help_text="Select `not applicable` if site was not selected for integrated care.",
                max_length=25,
                verbose_name="Was care for this `condition` delivered in an integrated care clinic today?",
            ),
        ),
        migrations.AddField(
            model_name="historicaldmreview",
            name="care_delivery_other",
            field=models.TextField(
                blank=True, null=True, verbose_name="If no, please explain"
            ),
        ),
        migrations.AddField(
            model_name="historicalhivreview",
            name="care_delivery",
            field=models.CharField(
                choices=[("Yes", "Yes"), ("No", "No"), ("N/A", "Not applicable")],
                default="N/A",
                help_text="Select `not applicable` if site was not selected for integrated care.",
                max_length=25,
                verbose_name="Was care for this `condition` delivered in an integrated care clinic today?",
            ),
        ),
        migrations.AddField(
            model_name="historicalhivreview",
            name="care_delivery_other",
            field=models.TextField(
                blank=True, null=True, verbose_name="If no, please explain"
            ),
        ),
        migrations.AddField(
            model_name="historicalhtnreview",
            name="care_delivery",
            field=models.CharField(
                choices=[("Yes", "Yes"), ("No", "No"), ("N/A", "Not applicable")],
                default="N/A",
                help_text="Select `not applicable` if site was not selected for integrated care.",
                max_length=25,
                verbose_name="Was care for this `condition` delivered in an integrated care clinic today?",
            ),
        ),
        migrations.AddField(
            model_name="historicalhtnreview",
            name="care_delivery_other",
            field=models.TextField(
                blank=True, null=True, verbose_name="If no, please explain"
            ),
        ),
        migrations.AddField(
            model_name="hivreview",
            name="care_delivery",
            field=models.CharField(
                choices=[("Yes", "Yes"), ("No", "No"), ("N/A", "Not applicable")],
                default="N/A",
                help_text="Select `not applicable` if site was not selected for integrated care.",
                max_length=25,
                verbose_name="Was care for this `condition` delivered in an integrated care clinic today?",
            ),
        ),
        migrations.AddField(
            model_name="hivreview",
            name="care_delivery_other",
            field=models.TextField(
                blank=True, null=True, verbose_name="If no, please explain"
            ),
        ),
        migrations.AddField(
            model_name="htnreview",
            name="care_delivery",
            field=models.CharField(
                choices=[("Yes", "Yes"), ("No", "No"), ("N/A", "Not applicable")],
                default="N/A",
                help_text="Select `not applicable` if site was not selected for integrated care.",
                max_length=25,
                verbose_name="Was care for this `condition` delivered in an integrated care clinic today?",
            ),
        ),
        migrations.AddField(
            model_name="htnreview",
            name="care_delivery_other",
            field=models.TextField(
                blank=True, null=True, verbose_name="If no, please explain"
            ),
        ),
        migrations.AlterField(
            model_name="historicalhivreview",
            name="arv_initiation_actual_date",
            field=models.DateField(
                blank=True,
                null=True,
                verbose_name="Date started antiretroviral therapy (ART)",
            ),
        ),
        migrations.AlterField(
            model_name="historicalhivreview",
            name="test_date",
            field=models.DateField(
                blank=True,
                help_text="QUESTION_RETIRED",
                null=True,
                verbose_name="Date tested for HIV",
            ),
        ),
        migrations.AlterField(
            model_name="historicalhtnreview",
            name="care_start_date",
            field=models.DateField(
                blank=True, null=True, verbose_name="Date clinical management started"
            ),
        ),
        migrations.AlterField(
            model_name="historicalhtnreview",
            name="managed_by",
            field=models.CharField(
                choices=[
                    ("drugs", "Drugs / Medicine"),
                    ("diet_lifestyle", "Diet and lifestyle alone"),
                ],
                default="N/A",
                max_length=25,
                verbose_name="How will the patient's hypertension be managed going forward?",
            ),
        ),
        migrations.AlterField(
            model_name="historicalhtnreview",
            name="test_date",
            field=models.DateField(
                blank=True,
                editable=False,
                null=True,
                verbose_name="Date tested for Hypertension",
            ),
        ),
        migrations.AlterField(
            model_name="hivreview",
            name="arv_initiation_actual_date",
            field=models.DateField(
                blank=True,
                null=True,
                verbose_name="Date started antiretroviral therapy (ART)",
            ),
        ),
        migrations.AlterField(
            model_name="hivreview",
            name="test_date",
            field=models.DateField(
                blank=True,
                help_text="QUESTION_RETIRED",
                null=True,
                verbose_name="Date tested for HIV",
            ),
        ),
        migrations.AlterField(
            model_name="htnreview",
            name="care_start_date",
            field=models.DateField(
                blank=True, null=True, verbose_name="Date clinical management started"
            ),
        ),
        migrations.AlterField(
            model_name="htnreview",
            name="managed_by",
            field=models.CharField(
                choices=[
                    ("drugs", "Drugs / Medicine"),
                    ("diet_lifestyle", "Diet and lifestyle alone"),
                ],
                default="N/A",
                max_length=25,
                verbose_name="How will the patient's hypertension be managed going forward?",
            ),
        ),
        migrations.AlterField(
            model_name="htnreview",
            name="test_date",
            field=models.DateField(
                blank=True,
                editable=False,
                null=True,
                verbose_name="Date tested for Hypertension",
            ),
        ),
    ]
