# Generated by Django 3.1.8 on 2021-04-25 00:01

import _socket
from django.conf import settings
import django.contrib.sites.managers
import django.core.validators
from django.db import migrations, models
import django.db.models.deletion
import django_audit_fields.fields.hostname_modification_field
import django_audit_fields.fields.userfield
import django_audit_fields.fields.uuid_auto_field
import django_audit_fields.models.audit_model_mixin
import django_revision.revision_field
import edc_model.models.fields.other_charfield
import edc_model.models.validators.date
import edc_protocol.validators
import edc_utils.date
import edc_visit_tracking.managers
import simple_history.models
import uuid


class Migration(migrations.Migration):

    dependencies = [
        ('sites', '0002_alter_domain_unique'),
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ('inte_subject', '0078_auto_20210209_1509'),
    ]

    operations = [
        migrations.CreateModel(
            name='HealthEconomicsRevisedTwo',
            fields=[
            ],
            options={
                'verbose_name': 'Health Economics (Rev 2)',
                'verbose_name_plural': 'Health Economics (Rev 2)',
                'proxy': True,
                'indexes': [],
                'constraints': [],
            },
            bases=('inte_subject.healtheconomicsrevised',),
            managers=[
                ('on_site', django.contrib.sites.managers.CurrentSiteManager()),
                ('objects', edc_visit_tracking.managers.CrfModelManager()),
            ],
        ),
        migrations.AlterModelOptions(
            name='healtheconomicsrevised',
            options={'default_permissions': ('add', 'change', 'delete', 'view', 'export', 'import'), 'get_latest_by': 'modified', 'ordering': ('-modified', '-created'), 'verbose_name': 'Health Economics (Rev 1)', 'verbose_name_plural': 'Health Economics (Rev 1)'},
        ),
        migrations.AlterModelOptions(
            name='historicalhealtheconomicsrevised',
            options={'get_latest_by': 'history_date', 'ordering': ('-history_date', '-history_id'), 'verbose_name': 'historical Health Economics (Rev 1)'},
        ),
        migrations.AlterField(
            model_name='healtheconomicsrevised',
            name='accomodation_per_month',
            field=models.IntegerField(help_text='in local currency', null=True, verbose_name='How much do you/your family spend on rent (or house loan/mortgage) and utilities in a month?'),
        ),
        migrations.AlterField(
            model_name='healtheconomicsrevised',
            name='childcare',
            field=models.CharField(choices=[('Yes', 'Yes'), ('No', 'No')], max_length=15, null=True, verbose_name='Did you ask anyone else, such as your family member/friend to look after your child/children in order to come here?'),
        ),
        migrations.AlterField(
            model_name='healtheconomicsrevised',
            name='childcare_source',
            field=models.CharField(choices=[('N/A', 'Not applicable'), ('working', 'Working'), ('studying', 'Studying'), ('caring_for_children', 'Caring for children'), ('house_maintenance', 'House maintenance'), ('nothing', 'Nothing'), ('OTHER', 'Other, specify')], default='N/A', max_length=25, null=True, verbose_name='If Yes, what would they have been doing if they had not stayed to look after your child or children?'),
        ),
        migrations.AlterField(
            model_name='healtheconomicsrevised',
            name='finance_by_loan',
            field=models.CharField(choices=[('Yes', 'Yes'), ('No', 'No')], max_length=15, null=True, verbose_name='Did you take any loans to pay for your visit?'),
        ),
        migrations.AlterField(
            model_name='healtheconomicsrevised',
            name='finance_by_sale',
            field=models.CharField(choices=[('Yes', 'Yes'), ('No', 'No')], max_length=15, null=True, verbose_name='Do you sell anything to pay for your visit today?'),
        ),
        migrations.AlterField(
            model_name='healtheconomicsrevised',
            name='food_cost',
            field=models.IntegerField(help_text='In local currency', null=True, validators=[django.core.validators.MinValueValidator(0)], verbose_name='How much did you spend on food while you were at the health care faility today?'),
        ),
        migrations.AlterField(
            model_name='healtheconomicsrevised',
            name='food_per_month',
            field=models.IntegerField(help_text='in local currency', null=True, verbose_name='How much do you/your family spend on food in a month?'),
        ),
        migrations.AlterField(
            model_name='healtheconomicsrevised',
            name='healthcare_expenditure_total_month',
            field=models.IntegerField(help_text='In local currency', null=True, validators=[django.core.validators.MinValueValidator(0)], verbose_name='How much in total has been spent on your healthcare in the last month?'),
        ),
        migrations.AlterField(
            model_name='healtheconomicsrevised',
            name='healthcare_expenditure_total_month_today',
            field=models.IntegerField(help_text='In local currency', null=True, validators=[django.core.validators.MinValueValidator(0)], verbose_name='How much in total has been spent on your healthcare in the last month?'),
        ),
        migrations.AlterField(
            model_name='healtheconomicsrevised',
            name='hospital_time',
            field=models.CharField(help_text='in hours and minutes (format HH:MM)', max_length=5, null=True, verbose_name='How much time did you spend at the health care facility?'),
        ),
        migrations.AlterField(
            model_name='healtheconomicsrevised',
            name='household_income_per_month',
            field=models.IntegerField(help_text='in local currency', null=True, verbose_name='What is the total income in your household per month?'),
        ),
        migrations.AlterField(
            model_name='healtheconomicsrevised',
            name='income_per_month',
            field=models.IntegerField(help_text='in local currency', null=True, verbose_name='How much do you earn (take home) per month?'),
        ),
        migrations.AlterField(
            model_name='healtheconomicsrevised',
            name='is_highest_earner',
            field=models.CharField(choices=[('Yes', 'Yes'), ('No', 'No')], max_length=15, null=True, verbose_name='Are you the person who earns the highest income in your household?'),
        ),
        migrations.AlterField(
            model_name='healtheconomicsrevised',
            name='large_expenditure_year',
            field=models.IntegerField(help_text='e.g. furniture, electrical items, cars (in local currency)', null=True, verbose_name='How much have you spent on large items in the last year'),
        ),
        migrations.AlterField(
            model_name='healtheconomicsrevised',
            name='lost_income',
            field=models.CharField(choices=[('Yes', 'Yes'), ('No', 'No')], max_length=15, null=True, verbose_name='Did you lose earnings as a result of coming here today? '),
        ),
        migrations.AlterField(
            model_name='healtheconomicsrevised',
            name='missed_routine_activities',
            field=models.CharField(choices=[('working', 'Working'), ('studying', 'Studying'), ('caring_for_children', 'Caring for children'), ('house_maintenance', 'House maintenance'), ('nothing', 'Nothing'), ('OTHER', 'Other, please specify')], max_length=25, null=True, verbose_name='What would you be doing if you had not come to the health facility today?'),
        ),
        migrations.AlterField(
            model_name='healtheconomicsrevised',
            name='non_drug_activities_month',
            field=models.CharField(choices=[('Yes', 'Yes'), ('No', 'No')], max_length=15, null=True, verbose_name='Over the last month, did you spend money on other activities (not drugs) relating to your health?'),
        ),
        migrations.AlterField(
            model_name='healtheconomicsrevised',
            name='non_drug_activities_today',
            field=models.CharField(choices=[('Yes', 'Yes'), ('No', 'No')], max_length=15, null=True, verbose_name='Did you spend money on other activities (not drugs) relating to your health today?'),
        ),
        migrations.AlterField(
            model_name='healtheconomicsrevised',
            name='off_work_days',
            field=models.DecimalField(decimal_places=1, help_text='in days. (1,2,3 etc. If half-day 0.5)', max_digits=4, null=True, verbose_name='How much time did you take off work?'),
        ),
        migrations.AlterField(
            model_name='healtheconomicsrevised',
            name='transport_cost',
            field=models.IntegerField(help_text='Coming to the health care facility going back home. (In local currency)', null=True, verbose_name='How much did you spend on transport in total?'),
        ),
        migrations.AlterField(
            model_name='healtheconomicsrevised',
            name='travel_time',
            field=models.CharField(help_text='in hours and minutes (format HH:MM)', max_length=5, null=True, verbose_name='How long did it take you to reach here?'),
        ),
        migrations.AlterField(
            model_name='historicalhealtheconomicsrevised',
            name='accomodation_per_month',
            field=models.IntegerField(help_text='in local currency', null=True, verbose_name='How much do you/your family spend on rent (or house loan/mortgage) and utilities in a month?'),
        ),
        migrations.AlterField(
            model_name='historicalhealtheconomicsrevised',
            name='childcare',
            field=models.CharField(choices=[('Yes', 'Yes'), ('No', 'No')], max_length=15, null=True, verbose_name='Did you ask anyone else, such as your family member/friend to look after your child/children in order to come here?'),
        ),
        migrations.AlterField(
            model_name='historicalhealtheconomicsrevised',
            name='childcare_source',
            field=models.CharField(choices=[('N/A', 'Not applicable'), ('working', 'Working'), ('studying', 'Studying'), ('caring_for_children', 'Caring for children'), ('house_maintenance', 'House maintenance'), ('nothing', 'Nothing'), ('OTHER', 'Other, specify')], default='N/A', max_length=25, null=True, verbose_name='If Yes, what would they have been doing if they had not stayed to look after your child or children?'),
        ),
        migrations.AlterField(
            model_name='historicalhealtheconomicsrevised',
            name='finance_by_loan',
            field=models.CharField(choices=[('Yes', 'Yes'), ('No', 'No')], max_length=15, null=True, verbose_name='Did you take any loans to pay for your visit?'),
        ),
        migrations.AlterField(
            model_name='historicalhealtheconomicsrevised',
            name='finance_by_sale',
            field=models.CharField(choices=[('Yes', 'Yes'), ('No', 'No')], max_length=15, null=True, verbose_name='Do you sell anything to pay for your visit today?'),
        ),
        migrations.AlterField(
            model_name='historicalhealtheconomicsrevised',
            name='food_cost',
            field=models.IntegerField(help_text='In local currency', null=True, validators=[django.core.validators.MinValueValidator(0)], verbose_name='How much did you spend on food while you were at the health care faility today?'),
        ),
        migrations.AlterField(
            model_name='historicalhealtheconomicsrevised',
            name='food_per_month',
            field=models.IntegerField(help_text='in local currency', null=True, verbose_name='How much do you/your family spend on food in a month?'),
        ),
        migrations.AlterField(
            model_name='historicalhealtheconomicsrevised',
            name='healthcare_expenditure_total_month',
            field=models.IntegerField(help_text='In local currency', null=True, validators=[django.core.validators.MinValueValidator(0)], verbose_name='How much in total has been spent on your healthcare in the last month?'),
        ),
        migrations.AlterField(
            model_name='historicalhealtheconomicsrevised',
            name='healthcare_expenditure_total_month_today',
            field=models.IntegerField(help_text='In local currency', null=True, validators=[django.core.validators.MinValueValidator(0)], verbose_name='How much in total has been spent on your healthcare in the last month?'),
        ),
        migrations.AlterField(
            model_name='historicalhealtheconomicsrevised',
            name='hospital_time',
            field=models.CharField(help_text='in hours and minutes (format HH:MM)', max_length=5, null=True, verbose_name='How much time did you spend at the health care facility?'),
        ),
        migrations.AlterField(
            model_name='historicalhealtheconomicsrevised',
            name='household_income_per_month',
            field=models.IntegerField(help_text='in local currency', null=True, verbose_name='What is the total income in your household per month?'),
        ),
        migrations.AlterField(
            model_name='historicalhealtheconomicsrevised',
            name='income_per_month',
            field=models.IntegerField(help_text='in local currency', null=True, verbose_name='How much do you earn (take home) per month?'),
        ),
        migrations.AlterField(
            model_name='historicalhealtheconomicsrevised',
            name='is_highest_earner',
            field=models.CharField(choices=[('Yes', 'Yes'), ('No', 'No')], max_length=15, null=True, verbose_name='Are you the person who earns the highest income in your household?'),
        ),
        migrations.AlterField(
            model_name='historicalhealtheconomicsrevised',
            name='large_expenditure_year',
            field=models.IntegerField(help_text='e.g. furniture, electrical items, cars (in local currency)', null=True, verbose_name='How much have you spent on large items in the last year'),
        ),
        migrations.AlterField(
            model_name='historicalhealtheconomicsrevised',
            name='lost_income',
            field=models.CharField(choices=[('Yes', 'Yes'), ('No', 'No')], max_length=15, null=True, verbose_name='Did you lose earnings as a result of coming here today? '),
        ),
        migrations.AlterField(
            model_name='historicalhealtheconomicsrevised',
            name='missed_routine_activities',
            field=models.CharField(choices=[('working', 'Working'), ('studying', 'Studying'), ('caring_for_children', 'Caring for children'), ('house_maintenance', 'House maintenance'), ('nothing', 'Nothing'), ('OTHER', 'Other, please specify')], max_length=25, null=True, verbose_name='What would you be doing if you had not come to the health facility today?'),
        ),
        migrations.AlterField(
            model_name='historicalhealtheconomicsrevised',
            name='non_drug_activities_month',
            field=models.CharField(choices=[('Yes', 'Yes'), ('No', 'No')], max_length=15, null=True, verbose_name='Over the last month, did you spend money on other activities (not drugs) relating to your health?'),
        ),
        migrations.AlterField(
            model_name='historicalhealtheconomicsrevised',
            name='non_drug_activities_today',
            field=models.CharField(choices=[('Yes', 'Yes'), ('No', 'No')], max_length=15, null=True, verbose_name='Did you spend money on other activities (not drugs) relating to your health today?'),
        ),
        migrations.AlterField(
            model_name='historicalhealtheconomicsrevised',
            name='off_work_days',
            field=models.DecimalField(decimal_places=1, help_text='in days. (1,2,3 etc. If half-day 0.5)', max_digits=4, null=True, verbose_name='How much time did you take off work?'),
        ),
        migrations.AlterField(
            model_name='historicalhealtheconomicsrevised',
            name='transport_cost',
            field=models.IntegerField(help_text='Coming to the health care facility going back home. (In local currency)', null=True, verbose_name='How much did you spend on transport in total?'),
        ),
        migrations.AlterField(
            model_name='historicalhealtheconomicsrevised',
            name='travel_time',
            field=models.CharField(help_text='in hours and minutes (format HH:MM)', max_length=5, null=True, verbose_name='How long did it take you to reach here?'),
        ),
        migrations.CreateModel(
            name='HistoricalHealthEconomicsRevisedTwo',
            fields=[
                ('revision', django_revision.revision_field.RevisionField(blank=True, editable=False, help_text='System field. Git repository tag:branch:commit.', max_length=75, null=True, verbose_name='Revision')),
                ('created', models.DateTimeField(blank=True, default=django_audit_fields.models.audit_model_mixin.utcnow)),
                ('modified', models.DateTimeField(blank=True, default=django_audit_fields.models.audit_model_mixin.utcnow)),
                ('user_created', django_audit_fields.fields.userfield.UserField(blank=True, help_text='Updated by admin.save_model', max_length=50, verbose_name='user created')),
                ('user_modified', django_audit_fields.fields.userfield.UserField(blank=True, help_text='Updated by admin.save_model', max_length=50, verbose_name='user modified')),
                ('hostname_created', models.CharField(blank=True, default=_socket.gethostname, help_text='System field. (modified on create only)', max_length=60)),
                ('hostname_modified', django_audit_fields.fields.hostname_modification_field.HostnameModificationField(blank=True, help_text='System field. (modified on every save)', max_length=50)),
                ('device_created', models.CharField(blank=True, max_length=10)),
                ('device_modified', models.CharField(blank=True, max_length=10)),
                ('id', django_audit_fields.fields.uuid_auto_field.UUIDAutoField(blank=True, db_index=True, editable=False, help_text='System auto field. UUID primary key.')),
                ('report_datetime', models.DateTimeField(default=edc_utils.date.get_utcnow, help_text="If reporting today, use today's date/time, otherwise use the date/time this information was reported.", validators=[edc_protocol.validators.datetime_not_before_study_start, edc_model.models.validators.date.datetime_not_future], verbose_name='Report Date')),
                ('consent_model', models.CharField(editable=False, max_length=50, null=True)),
                ('consent_version', models.CharField(editable=False, max_length=10, null=True)),
                ('crf_status', models.CharField(choices=[('INCOMPLETE', 'Incomplete (some data pending)'), ('COMPLETE', 'Complete')], default='INCOMPLETE', help_text='If some data is still pending, flag this CRF as incomplete', max_length=25, verbose_name='CRF status')),
                ('crf_status_comments', models.TextField(blank=True, help_text='for example, why some data is still pending', null=True, verbose_name='Any comments related to status of this CRF')),
                ('history_id', models.UUIDField(default=uuid.uuid4, editable=False, primary_key=True, serialize=False)),
                ('occupation', models.CharField(max_length=50, verbose_name='What is your occupation/profession?')),
                ('education_in_years', models.IntegerField(validators=[django.core.validators.MinValueValidator(0), django.core.validators.MaxValueValidator(50)], verbose_name='How many years of education did you complete?')),
                ('education_certificate', models.CharField(blank=True, max_length=50, null=True, verbose_name='What is your highest education certificate?')),
                ('primary_school', models.CharField(choices=[('Yes', 'Yes'), ('No', 'No'), ('N/A', 'Not applicable')], max_length=15, verbose_name='Did you go to primary/elementary school?')),
                ('primary_school_in_years', models.IntegerField(blank=True, null=True, validators=[django.core.validators.MinValueValidator(0), django.core.validators.MaxValueValidator(10)], verbose_name='If YES, for how many years')),
                ('secondary_school', models.CharField(choices=[('Yes', 'Yes'), ('No', 'No'), ('N/A', 'Not applicable')], max_length=15, verbose_name='Did you go to secondary school?')),
                ('secondary_school_in_years', models.IntegerField(blank=True, null=True, validators=[django.core.validators.MinValueValidator(0), django.core.validators.MaxValueValidator(10)], verbose_name='If YES, for how many years')),
                ('higher_education', models.CharField(choices=[('Yes', 'Yes'), ('No', 'No'), ('N/A', 'Not applicable')], max_length=15, verbose_name='Did you go to higher education?')),
                ('higher_education_in_years', models.IntegerField(blank=True, null=True, validators=[django.core.validators.MinValueValidator(0), django.core.validators.MaxValueValidator(10)], verbose_name='If YES, for how many years')),
                ('welfare', models.CharField(choices=[('Yes', 'Yes'), ('No', 'No')], max_length=15, verbose_name='Do you receive any welfare or social service support')),
                ('income_per_month', models.IntegerField(help_text='in local currency', null=True, verbose_name='How much do you earn (take home) per month?')),
                ('household_income_per_month', models.IntegerField(help_text='in local currency', null=True, verbose_name='What is the total income in your household per month?')),
                ('is_highest_earner', models.CharField(choices=[('Yes', 'Yes'), ('No', 'No')], max_length=15, null=True, verbose_name='Are you the person who earns the highest income in your household?')),
                ('highest_earner', models.CharField(blank=True, max_length=50, null=True, verbose_name='If NO, what is the profession of the person who earns the highest income?')),
                ('food_per_month', models.IntegerField(help_text='in local currency', null=True, verbose_name='How much do you/your family spend on food in a month?')),
                ('accomodation_per_month', models.IntegerField(help_text='in local currency', null=True, verbose_name='How much do you/your family spend on rent (or house loan/mortgage) and utilities in a month?')),
                ('large_expenditure_year', models.IntegerField(help_text='e.g. furniture, electrical items, cars (in local currency)', null=True, verbose_name='How much have you spent on large items in the last year')),
                ('received_rx_month', models.CharField(choices=[('Yes', 'Yes'), ('No', 'No')], help_text='not including today', max_length=15, verbose_name='Over the last month, did you get any drugs on your visit to the health facility?')),
                ('rx_dm_month', models.CharField(choices=[('Yes', 'Yes'), ('No', 'No'), ('N/A', 'Not applicable')], default='N/A', help_text='not including today', max_length=15, verbose_name='Did you receive drugs for raised blood sugar (diabetes) over the last month?')),
                ('rx_dm_paid_month_other', edc_model.models.fields.other_charfield.OtherCharField(blank=True, max_length=35, null=True, verbose_name='If `other pay source`, please specify ... (DM)')),
                ('rx_dm_cost_month', models.IntegerField(blank=True, help_text='In local currency', null=True, validators=[django.core.validators.MinValueValidator(0)], verbose_name='If these drugs were not free, how much did you pay?')),
                ('rx_htn_month', models.CharField(choices=[('Yes', 'Yes'), ('No', 'No'), ('N/A', 'Not applicable')], default='N/A', help_text='not including today', max_length=15, verbose_name='Did you receive drugs for raised blood pressure (hypertension) over the last month?')),
                ('rx_htn_paid_month_other', edc_model.models.fields.other_charfield.OtherCharField(blank=True, max_length=35, null=True, verbose_name='If `other pay source`, please specify ...(HTN)')),
                ('rx_htn_cost_month', models.IntegerField(blank=True, help_text='In local currency', null=True, validators=[django.core.validators.MinValueValidator(0)], verbose_name='If these drugs were not free, how much did you pay?')),
                ('rx_hiv_month', models.CharField(choices=[('Yes', 'Yes'), ('No', 'No'), ('N/A', 'Not applicable')], default='N/A', help_text='not including today', max_length=15, verbose_name='Did you receive anti-retroviral drugs for HIV over the last month?')),
                ('rx_hiv_paid_month_other', edc_model.models.fields.other_charfield.OtherCharField(blank=True, max_length=35, null=True, verbose_name='If `other pay source`, please specify ... (HIV)')),
                ('rx_hiv_cost_month', models.IntegerField(blank=True, help_text='In local currency', null=True, validators=[django.core.validators.MinValueValidator(0)], verbose_name='If these drugs were not free, how much did you pay?')),
                ('rx_other_month', models.CharField(choices=[('Yes', 'Yes'), ('No', 'No'), ('N/A', 'Not applicable')], default='N/A', max_length=15, verbose_name="Did you receive any 'other' drugs?")),
                ('rx_other_paid_month_other', edc_model.models.fields.other_charfield.OtherCharField(blank=True, max_length=35, null=True, verbose_name='If `other pay source`, please specify ...')),
                ('rx_other_cost_month', models.IntegerField(blank=True, help_text='In local currency', null=True, validators=[django.core.validators.MinValueValidator(0)], verbose_name="If not free, how much did you pay for these 'other' drugs?")),
                ('non_drug_activities_month', models.CharField(choices=[('Yes', 'Yes'), ('No', 'No')], max_length=15, null=True, verbose_name='Over the last month, did you spend money on other activities (not drugs) relating to your health?')),
                ('non_drug_activities_detail_month', models.TextField(blank=True, null=True, verbose_name='If YES, what was the activity')),
                ('non_drug_activities_cost_month', models.IntegerField(blank=True, help_text='In local currency', null=True, validators=[django.core.validators.MinValueValidator(0)], verbose_name='If YES, how much was spent on other activities (not drugs) relating to your health?')),
                ('healthcare_expenditure_total_month', models.IntegerField(help_text='In local currency', null=True, validators=[django.core.validators.MinValueValidator(0)], verbose_name='How much in total has been spent on your healthcare in the last month?')),
                ('missed_routine_activities', models.CharField(choices=[('working', 'Working'), ('studying', 'Studying'), ('caring_for_children', 'Caring for children'), ('house_maintenance', 'House maintenance'), ('nothing', 'Nothing'), ('OTHER', 'Other, please specify')], max_length=25, null=True, verbose_name='What would you be doing if you had not come to the health facility today?')),
                ('missed_routine_activities_other', models.CharField(blank=True, max_length=50, null=True, verbose_name='If OTHER, please specify')),
                ('off_work_days', models.DecimalField(decimal_places=1, help_text='in days. (1,2,3 etc. If half-day 0.5)', max_digits=4, null=True, verbose_name='How much time did you take off work?')),
                ('travel_time', models.CharField(help_text='in hours and minutes (format HH:MM)', max_length=5, null=True, verbose_name='How long did it take you to reach here?')),
                ('hospital_time', models.CharField(help_text='in hours and minutes (format HH:MM)', max_length=5, null=True, verbose_name='How much time did you spend at the health care facility?')),
                ('lost_income', models.CharField(choices=[('Yes', 'Yes'), ('No', 'No')], max_length=15, null=True, verbose_name='Did you lose earnings as a result of coming here today? ')),
                ('lost_income_amount', models.IntegerField(blank=True, help_text='In local currency', null=True, validators=[django.core.validators.MinValueValidator(0)], verbose_name='If Yes, how much did you lose?')),
                ('childcare', models.CharField(choices=[('Yes', 'Yes'), ('No', 'No')], max_length=15, null=True, verbose_name='Did you ask anyone else, such as your family member/friend to look after your child/children in order to come here?')),
                ('childcare_source', models.CharField(choices=[('N/A', 'Not applicable'), ('working', 'Working'), ('studying', 'Studying'), ('caring_for_children', 'Caring for children'), ('house_maintenance', 'House maintenance'), ('nothing', 'Nothing'), ('OTHER', 'Other, specify')], default='N/A', max_length=25, null=True, verbose_name='If Yes, what would they have been doing if they had not stayed to look after your child or children?')),
                ('childcare_source_other', edc_model.models.fields.other_charfield.OtherCharField(blank=True, max_length=35, null=True, verbose_name='If other, please specify ...')),
                ('childcare_source_timeoff', models.DecimalField(blank=True, decimal_places=1, help_text='in days. (1,2,3 etc. If half-day 0.5)', max_digits=4, null=True, verbose_name='How much time did a family member or friend take off?')),
                ('transport_other', edc_model.models.fields.other_charfield.OtherCharField(blank=True, max_length=35, null=True, verbose_name='If `other reason`, please specify ...')),
                ('transport_cost', models.IntegerField(help_text='Coming to the health care facility going back home. (In local currency)', null=True, verbose_name='How much did you spend on transport in total?')),
                ('food_cost', models.IntegerField(help_text='In local currency', null=True, validators=[django.core.validators.MinValueValidator(0)], verbose_name='How much did you spend on food while you were at the health care faility today?')),
                ('received_rx_today', models.CharField(choices=[('Yes', 'Yes'), ('No', 'No')], max_length=15, verbose_name='Did you get any drugs on your visit to the health facility today?')),
                ('rx_dm_today', models.CharField(choices=[('Yes', 'Yes'), ('No', 'No'), ('N/A', 'Not applicable')], default='N/A', max_length=15, verbose_name='Did you receive drugs for raised blood sugar (diabetes) today?')),
                ('rx_dm_paid_today_other', edc_model.models.fields.other_charfield.OtherCharField(blank=True, max_length=35, null=True, verbose_name='If `other pay source`, please specify ...')),
                ('rx_dm_cost_today', models.IntegerField(blank=True, help_text='In local currency', null=True, validators=[django.core.validators.MinValueValidator(0)], verbose_name='If not free, how much did you pay for raised blood sugar (diabetes) drugs?')),
                ('rx_htn_today', models.CharField(choices=[('Yes', 'Yes'), ('No', 'No'), ('N/A', 'Not applicable')], default='N/A', max_length=15, verbose_name='Did you receive raised blood pressure (hypertension) drugs today?')),
                ('rx_htn_paid_today_other', edc_model.models.fields.other_charfield.OtherCharField(blank=True, max_length=35, null=True, verbose_name='If `other pay source`, please specify ...')),
                ('rx_htn_cost_today', models.IntegerField(blank=True, help_text='In local currency', null=True, validators=[django.core.validators.MinValueValidator(0)], verbose_name='If not free, how much did you pay for high blood pressure (Hypertension) drugs?')),
                ('rx_hiv_today', models.CharField(choices=[('Yes', 'Yes'), ('No', 'No'), ('N/A', 'Not applicable')], default='N/A', max_length=15, verbose_name='Did you receive ARVs (HIV) today?')),
                ('rx_hiv_paid_today_other', edc_model.models.fields.other_charfield.OtherCharField(blank=True, max_length=35, null=True, verbose_name='If `other pay source`, please specify ...')),
                ('rx_hiv_cost_today', models.IntegerField(blank=True, help_text='In local currency', null=True, validators=[django.core.validators.MinValueValidator(0)], verbose_name='If not free, how much did you pay for ARV (HIV) drugs?')),
                ('rx_other_today', models.CharField(choices=[('Yes', 'Yes'), ('No', 'No'), ('N/A', 'Not applicable')], default='N/A', max_length=15, verbose_name="Did you receive 'other' drugs today?")),
                ('rx_other_paid_today_other', edc_model.models.fields.other_charfield.OtherCharField(blank=True, max_length=35, null=True, verbose_name='If `other pay source`, please specify ...')),
                ('rx_other_cost_today', models.IntegerField(blank=True, help_text='In local currency', null=True, validators=[django.core.validators.MinValueValidator(0)], verbose_name="If not free, how much did you pay for these 'other' drugs?")),
                ('non_drug_activities_today', models.CharField(choices=[('Yes', 'Yes'), ('No', 'No')], max_length=15, null=True, verbose_name='Did you spend money on other activities (not drugs) relating to your health today?')),
                ('non_drug_activities_detail_today', models.TextField(blank=True, null=True, verbose_name='If YES, what was the activity')),
                ('non_drug_activities_cost_today', models.IntegerField(blank=True, help_text='In local currency', null=True, validators=[django.core.validators.MinValueValidator(0)], verbose_name='If YES, how much did you spend?')),
                ('healthcare_expenditure_total_month_today', models.IntegerField(help_text='In local currency', null=True, validators=[django.core.validators.MinValueValidator(0)], verbose_name='How much in total has been spent on your healthcare in the last month?')),
                ('finance_by_sale', models.CharField(choices=[('Yes', 'Yes'), ('No', 'No')], max_length=15, null=True, verbose_name='Do you sell anything to pay for your visit today?')),
                ('finance_by_loan', models.CharField(choices=[('Yes', 'Yes'), ('No', 'No')], max_length=15, null=True, verbose_name='Did you take any loans to pay for your visit?')),
                ('health_insurance', models.CharField(choices=[('Yes', 'Yes'), ('No', 'No')], max_length=15, verbose_name='Do you have private healthcare insurance?')),
                ('health_insurance_cost', models.IntegerField(blank=True, help_text='in local currency', null=True, verbose_name='If Yes, how much do you pay towards your contributions to healthcare insurance every month?')),
                ('patient_club', models.CharField(choices=[('Yes', 'Yes'), ('No', 'No')], max_length=15, verbose_name='Do you contribute to a patient club?')),
                ('patient_club_cost', models.IntegerField(blank=True, help_text='in local currency', null=True, verbose_name='If Yes, how much do you pay towards your contributions to the patient club every month?')),
                ('history_date', models.DateTimeField()),
                ('history_change_reason', models.CharField(max_length=100, null=True)),
                ('history_type', models.CharField(choices=[('+', 'Created'), ('~', 'Changed'), ('-', 'Deleted')], max_length=1)),
                ('history_user', models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('site', models.ForeignKey(blank=True, db_constraint=False, editable=False, null=True, on_delete=django.db.models.deletion.DO_NOTHING, related_name='+', to='sites.site')),
                ('subject_visit', models.ForeignKey(blank=True, db_constraint=False, null=True, on_delete=django.db.models.deletion.DO_NOTHING, related_name='+', to='inte_subject.subjectvisit')),
            ],
            options={
                'verbose_name': 'historical Health Economics (Rev 2)',
                'ordering': ('-history_date', '-history_id'),
                'get_latest_by': 'history_date',
            },
            bases=(simple_history.models.HistoricalChanges, models.Model),
        ),
    ]
